// Charge Projection Actor Dynamics

Escapismal.Actors.add('tpotm_charge_projection', (function () {
    let dec = '↊',
        el = '↋';

    let bar = document.createElement('div'),
        text = document.createElement('p'),
        charge = 20;

    function formatDozenal(decimal) {
        let format = Number(decimal).toString(12).replace(/a/g, dec).replace(/b/g, el).replace(/\./g, ';');
        if (format.indexOf(';') === -1) {
            format += ';0';
        }
        format = format.substr(0, format.indexOf(';') + 2);
        return format;
    }

    function init(context) {
        let gameState = context.gameState;
        let container = document.getElementById('obj_charge_projection');
        bar.classList.add('projection-bar');
        text.classList.add('projection-text');
        container.appendChild(bar);
        container.appendChild(text);

        let interval = window.setInterval(function () {
            charge += 1. / 12;

            text.innerHTML = generateDrawnString(formatDozenal(charge) + '%');
            bar.style.height = (charge / 2) + '%';

            if (charge >= 137) {
                context.eventHandler.process([{type: 'tpotm_charge_projection_ended', payload: {}}]);
            }
        }, 1000 / 24);

        function end() {
            charge = 137.5;
            text.innerHTML = generateDrawnString(formatDozenal(charge) + '%');
            bar.style.height = (charge / 2) + '%';
            window.clearInterval(interval);
        }

        let eventListener = {
            process: function (event) {
                if (event.type === 'tpotm_charge_projection_ended') {
                    end();
                    return true;
                }
                return false;
            }
        };

        context.eventHandler.addListener(eventListener);
    }

    return {
        init: init
    }
})());